
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//Функция очистки одного канала в EEPRO

void clearTimeChannel(byte channel);
{
  byte temp, M;
  if(channel == 1 || channel == 9)  M = 254; //Определяем для каналов маску 11111110
  if(channel == 2 || channel == 10) M = 253; //Определяем для каналов маску 11111101
  if(channel == 3 || channel == 11) M = 251; //Определяем для каналов маску 11111011
  if(channel == 4 || channel == 12) M = 247; //Определяем для каналов маску 11110111
  if(channel == 5 || channel == 13) M = 239; //Определяем для каналов маску 11101111
  if(channel == 6 || channel == 14) M = 223; //Определяем для каналов маску 11011111
  if(channel == 7 || channel == 15) M = 191; //Определяем для каналов маску 10111111
  if(channel == 8 || channel == 16) M = 127; //Определяем для каналов маску 01111111

  for(int i=0;i<1440;i++)  //Проходим в цикле все 24 часа
  {
    if(channel<9)    //если кинал меньше 9 то берем второй байт таблици из EEPROM
    {
      temp = EEPROM.read((i*2)+1);  //читаем второй байт соответствующий времени i
      temp = temp & M;              //Накладываем маску обнуляя соответствующий каналу бит
      EEPROM.write((i*2)+1, temp);  //Записываем получившееся значение обратно по тому же адресу
    }
    else
    if(channel<17)    //если кинал меньше 17 но больше 9 то берем первый байт таблици из EEPROM  
    {
      temp = EEPROM.read(i*2);  //читаем первый байт соответствующий времени i
      temp = temp & M;          //Накладываем маску обнуляя соответствующий каналу бит
      EEPROM.write(i*2, temp);  //Записываем получившееся значение обратно по тому же адресу
    }
  }
  
  if(channel == 10)  //Если это канал подмены воды обнуляем все данные по подмену
     for(int i = 2887;i<=2908;i++) EEPROM.write(i, 0);
  
  //Определяем и отображаем следующее событие
//  SetMessage((tm.Hour*60)+tm.Minute); 

  return;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//Функция записи включения канала chanel в EEPROB с о времени Chas_vkl,Min_vkl до времени Chas_otk, Min_otk
void setTimeTad(byte channel, int Chas_vkl, int Min_vkl, int Chas_otk, int Min_otk)
{
  byte temp, M;
  int EEPROM_TIME_VKL = 0; //начальное значение времени в таблице соответствует полуночи
  int EEPROM_TIME_OTK = 0; //начальное значение времени в таблице соответствует полуночи

  EEPROM_TIME_VKL = Min_vkl + Chas_vkl*60; //Расчитываем номер строки в таблице соответствующей времени включения в минутах от полуночи 
  EEPROM_TIME_OTK = (Min_otk + Chas_otk*60); //Расчитываем номер строки в таблице соответствующей времени выключения в минутах от полуночи

  if(channel == 1 || channel == 9)  M = 1;  //Определяем для каналов маску 00000001
  if(channel == 2 || channel == 10) M = 2;  //Определяем для каналов маску 00000010
  if(channel == 3 || channel == 11) M = 4;  //Определяем для каналов маску 00000100
  if(channel == 4 || channel == 12) M = 8;  //Определяем для каналов маску 00001000
  if(channel == 5 || channel == 13) M = 16; //Определяем для каналов маску 00010000
  if(channel == 6 || channel == 14) M = 32; //Определяем для каналов маску 00100000
  if(channel == 7 || channel == 15) M = 64; //Определяем для каналов маску 01000000
  if(channel == 8 || channel == 16) M = 128;//Определяем для каналов маску 10000000

  if(EEPROM_TIME_VKL == EEPROM_TIME_OTK) return;//Если время включения равно времени выключения то ничего не делаем

  if(EEPROM_TIME_VKL < EEPROM_TIME_OTK) //Если время включения меньше времени выключения то вся работа происходит до полуночи
  {
    if(channel<9)//если кинал меньше 9 то берем второй байт таблици из EEPROM
    {
      for(int i=EEPROM_TIME_VKL;i<EEPROM_TIME_OTK;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read((i*2)+1);  //читаем второй байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1
        EEPROM.write((i*2)+1, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
    else
    if(channel<17)   //если кинал меньше 17 но больше 9 то берем первый байт таблици из EEPROM
    {
      for(int i=EEPROM_TIME_VKL;i<EEPROM_TIME_OTK;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read(i*2);  //читаем первый байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1  
        EEPROM.write(i*2, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
  } 
  else //Если время включения больше времени выключения то выключение произойдет после полуночи
  {
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Заносим значения до полуночи строка 1439 23часа 59мин
    if(channel<9)//если кинал меньше 9 то берем второй байт таблици из EEPROM
    {
      for(int i=EEPROM_TIME_VKL;i<1440;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read((i*2)+1);  //читаем второй байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1
        EEPROM.write((i*2)+1, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
    else
    if(channel<17)   //если кинал меньше 17 но больше 9 то берем первый байт таблици из EEPROM
    {
      for(int i=EEPROM_TIME_VKL;i<1440;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read(i*2);  //читаем первый байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1  
        EEPROM.write(i*2, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
    //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    //Заносим значения после полуночи с 0часов 0мин
    if(channel<9)//если кинал меньше 9 то берем второй байт таблици из EEPROM
    {
      for(int i=0;i<EEPROM_TIME_OTK;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read((i*2)+1);  //читаем второй байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1
        EEPROM.write((i*2)+1, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
    else
    if(channel<17)   //если кинал меньше 17 но больше 9 то берем первый байт таблици из EEPROM
    {
      for(int i=0;i<EEPROM_TIME_OTK;i++)  //Переводим биты соответствующего канала п 1 от времени включения до времени выключения
      {
        temp = EEPROM.read(i*2);  //читаем первый байт соответствующий времени i
        if(temp & M) ;              //Если бит уже в 1 то пропускаем
        else temp += M;             //Если в 0 то устанавливаем в 1  
        EEPROM.write(i*2, temp);  //Записываем получившееся значение обратно по тому же адресу
      }
    }
    //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  }  

  //Определяем и отображаем следующее событие
//  SetMessage((tm.Hour*60)+tm.Minute); 

  return;
}

//================================================================================================================================================

//Управление первым источником света
void Svet_1(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_1, LOW);    //Включае свет
    //При включении первой лампы выключам ночную подсветку
    LEDON = false;
    Vulkan(false);  //Выключаем вулкан
  }  
  else
  {
    digitalWrite( RelePin_1, HIGH);   //Выключаем свет
    //При выключении последней лампы включам ночную подсветку
    LEDON = true;
    Vulkan(true);   //Включаем вулкан
  }
}

//================================================================================================================================================

//Управление вторым источником света
void Svet_2(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_2, LOW);    //Включае свет
  }  
  else
  {
    digitalWrite( RelePin_2, HIGH);   //Выключаем свет
  }
}

//================================================================================================================================================

//Управление третьим источником света
void Svet_3(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_3, LOW);    //Включае свет
  }  
  else
  {
    digitalWrite( RelePin_3, HIGH);   //Выключаем свет
  }
}

//================================================================================================================================================

//Управление четвертым источником света
void Svet_4(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_4, LOW);    //Включае свет
  }  
  else
  {
    digitalWrite( RelePin_4, HIGH);   //Выключаем свет
  }
}

//================================================================================================================================================

//Управление вулканом
void Vulkan(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_12, LOW);    //Включае свет
  }  
  else
  {
    digitalWrite( RelePin_12, HIGH);   //Выключаем свет
  }
}

//================================================================================================================================================

//Управление вентиляцией
void Ventilation(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( Ventilation_Pin, HIGH);    //Включаем
  }  
  else
  {
    digitalWrite( Ventilation_Pin, LOW);   //Выключаем
  }
}

//================================================================================================================================================

//Управление Охлаждением
void Cooling(boolean ON)
{
  if(ON && !Korm_ON) 
  { 
    digitalWrite( Cooling_Pin, HIGH);    //Включаем
    NagrevGround(false); //Отключаем нагрев грунта
  }  
  else
  {
    digitalWrite( Cooling_Pin, LOW);   //Выключаем
  }
}

//================================================================================================================================================

//Управление фильтром
void Filtr(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_6, LOW);    //Включаем
  }  
  else
  {
    digitalWrite( RelePin_6, HIGH);   //Выключаем
  }
}

//================================================================================================================================================

//Управление нагревателем воды
void NagrevWater(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_5, LOW);    //Включаем
  }  
  else
  {
    digitalWrite( RelePin_5, HIGH);   //Выключаем
  }
}

//================================================================================================================================================

//Управление нагревателем грунта
void NagrevGround(boolean ON)
{
  if(ON) 
  { 
    if(!digitalRead( Cooling_Pin )) digitalWrite( RelePin_8, LOW);    //Включаем нагрев грунта если не включено охлаждение
  }  
  else
  {
    digitalWrite( RelePin_8, HIGH);   //Выключаем
  }
}

//================================================================================================================================================

//Управление компрессором
void Kompressor(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_7, LOW);    //Включаем
  }  
  else
  {
    digitalWrite( RelePin_7, HIGH);   //Выключаем
  }
}

//================================================================================================================================================

//Управление клапаном CO2
void CO2(boolean ON)
{
  if(ON) 
  { 
    digitalWrite( RelePin_11, LOW);    //Включаем
  }  
  else
  {
    digitalWrite( RelePin_11, HIGH);   //Выключаем
  }
}

//================================================================================================================================================

//Управление кормушкой
void Kormushka()
{
   Korm_ON = true;
   Cooling(false);
   digitalWrite( Feeder_Pin, HIGH); //Даем команду на начало кормления
   delay(1000);                     //Ждем 1сек 
   digitalWrite( Feeder_Pin, LOW);  //Выключаем кормление
//   if(Displey == 2) SetMessage(((tm.Hour*60)+tm.Minute)+1); //Если выбран вариант дисплея 2 то определяем и отображаем следующее событие
} 

//================================================================================================================================================

//Управление клапана слива
void SlivStop()  //Остановка слива
{
   SLIV = false;  //Снимаем флаг слива воды

   //Даем сигнал на закрытие клапана слива
   digitalWrite( KlapanPin,  LOW);

   return;
} 

//================================================================================================================================================

//Управление клапана слива
void SlivStart()  //Начало слива
{
  //Отключам нагреватель
  SLIV_NAGREV = false;

  CountWaterLiter = 0;
  PulsesSensor = 0;

  lcd.clear();
  Displey = 2;
  
  digitalWrite( RelePin_5, HIGH); 
      
      
  //Закрываем клапана долива
//  digitalWrite( RelePin_13, HIGH); 
  digitalWrite( RelePin_14, HIGH); 
  digitalWrite( RelePin_15, HIGH); 

  //Открываем клапана слива
  digitalWrite( KlapanPin,  HIGH);

  return;
}  

//================================================================================================================================================

//Управление доливом канал 1
void DolivWater1(boolean ON)
{
  if(ON && digitalRead(SensorPin_A) && !SLIV && ServicesSTOP)
  {
    digitalWrite( RelePin_15, LOW);        //Открываем общий клапан
    digitalWrite( RelePin_14, LOW);        //Откраваем клапан 1
  }  
  else
  {
//    if(!digitalRead(SensorPin_2)) digitalWrite( RelePin_15, HIGH);       //Закрываем общий клапан 
    digitalWrite( RelePin_15, HIGH);       //Закрываем общий клапан
    digitalWrite( RelePin_14, HIGH);       //Закрываем клапан 1 
    if(!SLIV) SLIV_NAGREV = true;
  }
}

//================================================================================================================================================

//Управление доливом канал 2
void DolivWater2(boolean ON)
{
/*  if(ON && digitalRead(SensorPin_A) && !SLIV && ServicesSTOP)
  {
    digitalWrite( RelePin_15, LOW);        //Открываем общий клапан
    digitalWrite( RelePin_13, LOW);        //Откраваем клапан 2
  }  
  else
  {
    if(!digitalRead(SensorPin_1)) digitalWrite( RelePin_15, HIGH);       //Закрываем общий клапан 
    digitalWrite( RelePin_13, HIGH);       //Закрываем клапан 2 
  }*/
}

//================================================================================================================================================

void Udobrenie_Kanal_1(boolean ON)
{
  if(ON)
  {
    digitalWrite( RelePin_9, LOW);  //Даем команду на начало набора удобрения
  } 
  else
  {
    digitalWrite( RelePin_9, HIGH); //Даем команду на слив удобрения
  }
}

//================================================================================================================================================

void Udobrenie_Kanal_2(boolean ON)
{
  if(ON)
  {
    digitalWrite( RelePin_10, LOW);  //Даем команду на начало набора удобрения
  } 
  else
  {
    digitalWrite( RelePin_10, HIGH); //Даем команду на слив удобрения
  }
}

//================================================================================================================================================


